package de.ivu.elect.presentation.wahllokalsystem.table;

import java.util.Date;

import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatus;
import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusOnline;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;

public class WahllokalsystemOnlineStatusColumn extends AbstractWahllokalsystemStatusColumn<WahllokalsystemStatus> {

  private static final long serialVersionUID = 1L;


  private final Date now;

  private final Long timeoutInSeconds;

  public WahllokalsystemOnlineStatusColumn(Messages messages, Date now, Long timeoutInSeconds) {
    super("WahllokalsystemStatus-OnlineStatus", messages, "wahllokalsystem.status.online", ColumnType.COLOR,
        entity -> entity.getWahllokalsystemStatusOnline(now, timeoutInSeconds).getColor());
    this.now = now;
    this.timeoutInSeconds = timeoutInSeconds;
  }

  @Override
  public String getTooltip(WahllokalsystemStatus entity) {
    return getMessage(getStatusOnline(entity));
  }

  private WahllokalsystemStatusOnline getStatusOnline(WahllokalsystemStatus entity) {
    return entity.getWahllokalsystemStatusOnline(now, timeoutInSeconds);
  }

}
